"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.RETRYABLE_HTTP_METHODS = exports.RETRYABLE_STATUS_CODES = exports.RETRYABLE_ERROR_CODES = void 0;var _httpMethods = require("./http-methods");









/**
 * Error codes which can be retried
 */
const RETRYABLE_ERROR_CODES = new Set([
'EADDRINUSE',
'EAI_AGAIN',
'ECONNREFUSED',
'ECONNRESET',
'ENETUNREACH',
'ENOTFOUND',
'EPIPE',
'ETIMEDOUT']);


/**
 * HTTP status codes which can be retried
 */exports.RETRYABLE_ERROR_CODES = RETRYABLE_ERROR_CODES;
const RETRYABLE_STATUS_CODES = new Set([408, 413, 429, 500, 502, 503, 504, 521, 522, 524]);

/**
 * HTTP methods which can be retried
 */exports.RETRYABLE_STATUS_CODES = RETRYABLE_STATUS_CODES;
const RETRYABLE_HTTP_METHODS = new Set([
_httpMethods.HTTP_METHOD_DELETE,
_httpMethods.HTTP_METHOD_GET,
_httpMethods.HTTP_METHOD_HEAD,
_httpMethods.HTTP_METHOD_OPTIONS,
_httpMethods.HTTP_METHOD_PATCH,
_httpMethods.HTTP_METHOD_POST,
_httpMethods.HTTP_METHOD_PUT]);exports.RETRYABLE_HTTP_METHODS = RETRYABLE_HTTP_METHODS;
//# sourceMappingURL=retryable.js.map